diff --git a/meta/recipes-devtools/binutils/binutils-2.28.inc b/meta/recipes-devtools/binutils/binutils-2.28.inc
index 40b518bf7a..b37bb0e03a 100644
--- a/meta/recipes-devtools/binutils/binutils-2.28.inc
+++ b/meta/recipes-devtools/binutils/binutils-2.28.inc
@@ -18,7 +18,7 @@ BINUPV = "${@binutils_branch_version(d)}"
 
 UPSTREAM_CHECK_GITTAGREGEX = "binutils-(?P<pver>\d+_(\d_?)*)"
 
-SRCREV = "354199c7692c1bed53a2a15f0e4d531457e95f17"
+SRCREV = "cb44d42ce6ef0c7a4eed7e2a3c272ac102166850"
 SRC_URI = "\
      git://sourceware.org/git/binutils-gdb.git;branch=binutils-${BINUPV}-branch;protocol=git \
      file://0003-gprof-add-uclibc-support-to-configure.patch \
diff --git a/meta/recipes-devtools/binutils/binutils/CVE-2017-6965.patch b/meta/recipes-devtools/binutils/binutils/CVE-2017-6965.patch
index 1334c9444d..6697d4bc95 100644
--- a/meta/recipes-devtools/binutils/binutils/CVE-2017-6965.patch
+++ b/meta/recipes-devtools/binutils/binutils/CVE-2017-6965.patch
@@ -19,21 +19,6 @@ Signed-off-by: Yuanjie Huang <yuanjie.huang@windriver.com>
  binutils/readelf.c | 30 +++++++++++++++++++++++++-----
  2 files changed, 32 insertions(+), 5 deletions(-)
 
-diff --git a/binutils/ChangeLog b/binutils/ChangeLog
-index f21867f98c..e789a3b99b 100644
---- a/binutils/ChangeLog
-+++ b/binutils/ChangeLog
-@@ -1,3 +1,10 @@
-+2017-02-13  Nick Clifton  <nickc@redhat.com>
-+
-+	PR binutils/21137
-+	* readelf.c (target_specific_reloc_handling): Add end parameter.
-+	Check for buffer overflow before writing relocated values.
-+	(apply_relocations): Pass end to target_specific_reloc_handling.
-+
- 2017-03-02  Tristan Gingold  <gingold@adacore.com>
- 
- 	* configure: Regenerate.
 diff --git a/binutils/readelf.c b/binutils/readelf.c
 index b5f577f5a1..8cdaae3b8c 100644
 --- a/binutils/readelf.c
diff --git a/meta/recipes-devtools/binutils/binutils/CVE-2017-6966.patch b/meta/recipes-devtools/binutils/binutils/CVE-2017-6966.patch
index dd58df5fbf..206e493b6e 100644
--- a/meta/recipes-devtools/binutils/binutils/CVE-2017-6966.patch
+++ b/meta/recipes-devtools/binutils/binutils/CVE-2017-6966.patch
@@ -22,26 +22,6 @@ Signed-off-by: Yuanjie Huang <yuanjie.huang@windriver.com>
  binutils/readelf.c | 109 +++++++++++++++++++++++++++++++++++++++++------------
  2 files changed, 94 insertions(+), 25 deletions(-)
 
-diff --git a/binutils/ChangeLog b/binutils/ChangeLog
-index e789a3b99b..bd63c8a0d8 100644
---- a/binutils/ChangeLog
-+++ b/binutils/ChangeLog
-@@ -1,5 +1,15 @@
- 2017-02-13  Nick Clifton  <nickc@redhat.com>
- 
-+	PR binutils/21139
-+	* readelf.c (target_specific_reloc_handling): Add num_syms
-+	parameter.  Check for symbol table overflow before accessing
-+	symbol value.  If reloc pointer is NULL, discard all saved state.
-+	(apply_relocations): Pass num_syms to target_specific_reloc_handling.
-+	Call target_specific_reloc_handling with a NULL reloc pointer
-+	after processing all of the relocs.
-+
-+2017-02-13  Nick Clifton  <nickc@redhat.com>
-+
- 	PR binutils/21137
- 	* readelf.c (target_specific_reloc_handling): Add end parameter.
- 	Check for buffer overflow before writing relocated values.
 diff --git a/binutils/readelf.c b/binutils/readelf.c
 index 8cdaae3b8c..7c158c6342 100644
 --- a/binutils/readelf.c
diff --git a/meta/recipes-devtools/binutils/binutils/CVE-2017-6969.patch b/meta/recipes-devtools/binutils/binutils/CVE-2017-6969.patch
index ed5403430c..7dfa3d87c3 100644
--- a/meta/recipes-devtools/binutils/binutils/CVE-2017-6969.patch
+++ b/meta/recipes-devtools/binutils/binutils/CVE-2017-6969.patch
@@ -17,20 +17,6 @@ Signed-off-by: Yuanjie Huang <yuanjie.huang@windriver.com>
  binutils/readelf.c | 10 ++++++++--
  2 files changed, 14 insertions(+), 2 deletions(-)
 
-diff --git a/binutils/ChangeLog b/binutils/ChangeLog
-index bd63c8a0d8..1d840b42f9 100644
---- a/binutils/ChangeLog
-+++ b/binutils/ChangeLog
-@@ -1,3 +1,9 @@
-+2017-02-17  Nick Clifton  <nickc@redhat.com>
-+
-+	PR binutils/21156
-+	* readelf.c (find_section_in_set): Test for invalid section
-+	indicies.
-+
- 2017-02-13  Nick Clifton  <nickc@redhat.com>
- 
- 	PR binutils/21139
 diff --git a/binutils/readelf.c b/binutils/readelf.c
 index 7c158c6342..4960491c5c 100644
 --- a/binutils/readelf.c
diff --git a/meta/recipes-devtools/binutils/binutils/CVE-2017-6969_2.patch b/meta/recipes-devtools/binutils/binutils/CVE-2017-6969_2.patch
index 59a5dec675..5409511a7c 100644
--- a/meta/recipes-devtools/binutils/binutils/CVE-2017-6969_2.patch
+++ b/meta/recipes-devtools/binutils/binutils/CVE-2017-6969_2.patch
@@ -21,24 +21,6 @@ Signed-off-by: Yuanjie Huang <yuanjie.huang@windriver.com>
  binutils/dwarf.c   | 34 ++++++++++++++++++++--------------
  2 files changed, 30 insertions(+), 14 deletions(-)
 
-diff --git a/binutils/ChangeLog b/binutils/ChangeLog
-index 1d840b42f9..53352c1801 100644
---- a/binutils/ChangeLog
-+++ b/binutils/ChangeLog
-@@ -1,3 +1,13 @@
-+2017-02-20  Nick Clifton  <nickc@redhat.com>
-+
-+	PR binutils/21156
-+	* dwarf.c (cu_tu_indexes_read): Move into...
-+	(load_cu_tu_indexes): ... here.  Change the variable into
-+	tri-state.  Change the function into boolean, returning
-+	false if the indicies could not be loaded.
-+	(find_cu_tu_set): Return NULL if the indicies could not be
-+	loaded.
-+
- 2017-02-17  Nick Clifton  <nickc@redhat.com>
- 
- 	PR binutils/21156
 diff --git a/binutils/dwarf.c b/binutils/dwarf.c
 index 0184a7ab2e..6d879c9b61 100644
 --- a/binutils/dwarf.c
diff --git a/meta/recipes-devtools/binutils/binutils/CVE-2017-7209.patch b/meta/recipes-devtools/binutils/binutils/CVE-2017-7209.patch
index 2357a12836..b14441b4e3 100644
--- a/meta/recipes-devtools/binutils/binutils/CVE-2017-7209.patch
+++ b/meta/recipes-devtools/binutils/binutils/CVE-2017-7209.patch
@@ -16,20 +16,6 @@ Signed-off-by: Yuanjie Huang <yuanjie.huang@windriver.com>
  binutils/readelf.c | 16 ++++++++++++----
  2 files changed, 18 insertions(+), 4 deletions(-)
 
-diff --git a/binutils/ChangeLog b/binutils/ChangeLog
-index 53352c1801..cf92744c12 100644
---- a/binutils/ChangeLog
-+++ b/binutils/ChangeLog
-@@ -1,3 +1,9 @@
-+2017-02-13  Nick Clifton  <nickc@redhat.com>
-+
-+	PR binutils/21135
-+	* readelf.c (dump_section_as_bytes): Handle the case where
-+	uncompress_section_contents returns false.
-+
- 2017-02-20  Nick Clifton  <nickc@redhat.com>
- 
- 	PR binutils/21156
 diff --git a/binutils/readelf.c b/binutils/readelf.c
 index 4960491c5c..f0e7b080e8 100644
 --- a/binutils/readelf.c
diff --git a/meta/recipes-devtools/binutils/binutils/CVE-2017-7210.patch b/meta/recipes-devtools/binutils/binutils/CVE-2017-7210.patch
index 8791792c7c..f8ad32f4f8 100644
--- a/meta/recipes-devtools/binutils/binutils/CVE-2017-7210.patch
+++ b/meta/recipes-devtools/binutils/binutils/CVE-2017-7210.patch
@@ -17,21 +17,6 @@ Signed-off-by: Yuanjie Huang <yuanjie.huang@windriver.com>
  binutils/stabs.c   | 14 +++++++++++++-
  2 files changed, 20 insertions(+), 1 deletion(-)
 
-diff --git a/binutils/ChangeLog b/binutils/ChangeLog
-index cf92744c12..0045fbaaa6 100644
---- a/binutils/ChangeLog
-+++ b/binutils/ChangeLog
-@@ -1,3 +1,10 @@
-+2017-02-14  Nick Clifton  <nickc@redhat.com>
-+
-+	PR binutils/21157
-+	* stabs.c (parse_stab_enum_type): Check for corrupt NAME:VALUE
-+	pairs.
-+	(parse_number): Exit early if passed an empty string.
-+
- 2017-02-13  Nick Clifton  <nickc@redhat.com>
- 
- 	PR binutils/21135
 diff --git a/binutils/stabs.c b/binutils/stabs.c
 index f5c5d2d8e0..5d013cc361 100644
 --- a/binutils/stabs.c